/*******************************************************************************
* File Name: Pin_04.h  
* Version 1.50
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_Pin_04_H) /* Pins Pin_04_H */
#define CY_PINS_Pin_04_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Pin_04_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    Pin_04_Write(uint8 value) ;
void    Pin_04_SetDriveMode(uint8 mode) ;
uint8   Pin_04_ReadDataReg(void) ;
uint8   Pin_04_Read(void) ;
uint8   Pin_04_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Pin_04_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define Pin_04_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define Pin_04_DM_RES_UP          PIN_DM_RES_UP
#define Pin_04_DM_RES_DWN         PIN_DM_RES_DWN
#define Pin_04_DM_OD_LO           PIN_DM_OD_LO
#define Pin_04_DM_OD_HI           PIN_DM_OD_HI
#define Pin_04_DM_STRONG          PIN_DM_STRONG
#define Pin_04_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define Pin_04_MASK               Pin_04__MASK
#define Pin_04_SHIFT              Pin_04__SHIFT
#define Pin_04_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Pin_04_PS                     (* (reg8 *) Pin_04__PS)
/* Data Register */
#define Pin_04_DR                     (* (reg8 *) Pin_04__DR)
/* Port Number */
#define Pin_04_PRT_NUM                (* (reg8 *) Pin_04__PRT) 
/* Connect to Analog Globals */                                                  
#define Pin_04_AG                     (* (reg8 *) Pin_04__AG)                       
/* Analog MUX bux enable */
#define Pin_04_AMUX                   (* (reg8 *) Pin_04__AMUX) 
/* Bidirectional Enable */                                                        
#define Pin_04_BIE                    (* (reg8 *) Pin_04__BIE)
/* Bit-mask for Aliased Register Access */
#define Pin_04_BIT_MASK               (* (reg8 *) Pin_04__BIT_MASK)
/* Bypass Enable */
#define Pin_04_BYP                    (* (reg8 *) Pin_04__BYP)
/* Port wide control signals */                                                   
#define Pin_04_CTL                    (* (reg8 *) Pin_04__CTL)
/* Drive Modes */
#define Pin_04_DM0                    (* (reg8 *) Pin_04__DM0) 
#define Pin_04_DM1                    (* (reg8 *) Pin_04__DM1)
#define Pin_04_DM2                    (* (reg8 *) Pin_04__DM2) 
/* Input Buffer Disable Override */
#define Pin_04_INP_DIS                (* (reg8 *) Pin_04__INP_DIS)
/* LCD Common or Segment Drive */
#define Pin_04_LCD_COM_SEG            (* (reg8 *) Pin_04__LCD_COM_SEG)
/* Enable Segment LCD */
#define Pin_04_LCD_EN                 (* (reg8 *) Pin_04__LCD_EN)
/* Slew Rate Control */
#define Pin_04_SLW                    (* (reg8 *) Pin_04__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Pin_04_PRTDSI__CAPS_SEL       (* (reg8 *) Pin_04__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Pin_04_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Pin_04__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Pin_04_PRTDSI__OE_SEL0        (* (reg8 *) Pin_04__PRTDSI__OE_SEL0) 
#define Pin_04_PRTDSI__OE_SEL1        (* (reg8 *) Pin_04__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Pin_04_PRTDSI__OUT_SEL0       (* (reg8 *) Pin_04__PRTDSI__OUT_SEL0) 
#define Pin_04_PRTDSI__OUT_SEL1       (* (reg8 *) Pin_04__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Pin_04_PRTDSI__SYNC_OUT       (* (reg8 *) Pin_04__PRTDSI__SYNC_OUT) 


#if defined(Pin_04__INTSTAT)  /* Interrupt Registers */

    #define Pin_04_INTSTAT                (* (reg8 *) Pin_04__INTSTAT)
    #define Pin_04_SNAP                   (* (reg8 *) Pin_04__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins Pin_04_H */


/* [] END OF FILE */
