//============Strob_Mix

#include <device.h>
#include <stdio.h>

//#define Fsys			24576000
//#define Fsys			50379000
//#define Fsys			50310247
//#define Fsys			34000000
#define Fsys			33176000
#define Fdds			(Fsys/4)
//#define Fdds			17068273
//#define Fsys			67000000
//#define Fsys			67619849
#define Acc  16777216	//2^22

//PWM StatusReg
#define Cmp_out1		0x01
#define Cmp_out2		0x02
#define TermCnt			0x04
#define PWM_FIFO_full		0x08
#define PWM_FIFO_not_empty	0x10
#define Killoutput			0x20

#define CR 13

void UpdateF(void);
unsigned long atoul(char * s, unsigned base);
void Convert(void);
void Convertx(void);
void Set_Fs(void);
void Display(void);
void SendStatus(void);
void PrintHelp(void);

uint8 Lo(uint32 Val);
uint8 Me(uint32 Val);
uint8 Hi(uint32 Val);

uint32 SysCnt = 0;
uint32 FCnt = 0;
uint32 Cap3 = 0;
uint32 Cap4 = 0;

char buff_LCD[40];
char buff_U[12];

char Ready=0;
uint8 trigger=0;
uint8 Auto=1;


char ch=0; // Data received from the Serial port
//uint8 count=0;
char count=0;
uint8 Ns=0;
uint8 K=1;
uint16 X=100;
uint16 Fo=100;
uint16 Xd;

float FreqX;
uint32 Freq=0;
float Fs=0;
uint32 Fsbak=0;
float PhaseF;
uint32 Phase; 

uint8	PhaseLo;
uint8	PhaseMe;
uint8	PhaseHi;

uint8 Gain[9]= {1,2,4,8,16,24,32,48,50};
uint8 Gain1[6]={0,1,2,3,4,    6};
uint8 GainL=0;
uint8 GainR=0;	
uint8 Sync=0;
void main()
{
    /* Place your initialization/startup code here (e.g. MyInst_Start()) */

	
	CYGlobalIntEnable; /* Enable all interrupts by the processor. */
	
	
	
	Opamp_0_Start();
	Opamp_2_Start();
	PGA_L_Start();
	PGA_R_Start();
	PGA_L_SetGain(GainL);
	PGA_R_SetGain(GainR);	
	isr_2_Start();
    LCD_Start();
	UART_1_Start();
	Mixer_L_Start();
	Mixer_R_Start();
	AMux_1_Start();
	AMux_1_Select(0);
	
	Debounce_Start();
	PWM_Window_Start();
	SysCounter_Start();
	FCounter_Start();
	Comp_1_Start();
	isr_1_Start();			
	
 	LCD_Position(0,0);
	LCD_PrintString("09.12.10 StrobM");
	CyDelay(255u);
	CyDelay(255u);
	CyDelay(255u);
	UART_1_PutString("\n\r>");
	UART_1_WriteTxData(13);
	UART_1_WriteTxData(10);
		
	while(1)
	{		
		if(trigger) // Indicates that data byte is received.
		{
			isr_1_Disable();
			trigger = 0; // Reset the trigger
			
			ch=UART_1_ReadRxData();
			UART_1_WriteTxData(ch);
			
			switch(ch)
			{
			case 'a' : Auto=1; isr_1_Enable(); break;
			case 'u' : X=X*10; isr_1_Enable(); break;
			case 'd' : X=X/10; isr_1_Enable(); break;
			case 's' : SendStatus(); isr_1_Enable(); break;
			case 'h' : PrintHelp(); isr_1_Enable(); break;
			case 'l' : AMux_1_Select(0); Sync=0; isr_1_Enable(); break;
			case 'r' : AMux_1_Select(1); Sync=1; isr_1_Enable(); break;
			
			case 'f' : GainL++; if(GainL>5)  GainL=5; PGA_L_SetGain(Gain1[GainL]); isr_1_Enable(); break;
			case 'v' : GainL--; if(GainL>10) GainL=0; PGA_L_SetGain(Gain1[GainL]); isr_1_Enable(); break;
			case 'g' : GainR++; if(GainR>5)  GainR=5; PGA_R_SetGain(Gain1[GainR]); isr_1_Enable(); break;
			case 'b' : GainR--; if(GainR>10) GainR=0; PGA_R_SetGain(Gain1[GainR]); isr_1_Enable(); break;
			}
			
			buff_U[count]=ch;
			count++;
			if ((ch==CR)|(ch ==10)) UpdateF();						
		}
		
		if (Ready) 				
		{	
//		isr_1_Disable();
			SysCnt = SysCounter_ReadCounter();			
			FCnt = FCounter_ReadCounter()-1;							
			
			SysCounter_WriteCounter(0);
			FCounter_WriteCounter(0);					
			
			FreqX = (float)FCnt/SysCnt;
			FreqX = (float)FreqX*Fsys;
			
			Freq = (uint32)FreqX;
									
			Convertx();
			if(Auto) Set_Fs();
			Display();
			
			Ready=0;
//		isr_1_Enable();	
		}				
    }
}

void SendStatus(void)
{
sprintf(buff_U, "\n\rFm=%7.1f\n\r",FreqX);
UART_1_PutString(buff_U);

sprintf(buff_U, "Fs=%7.1f\n\r",Fs);
UART_1_PutString(buff_U);

sprintf(buff_U, "Ph=%u\n\r",Phase);
UART_1_PutString(buff_U);

sprintf(buff_U, "Xd=%u\n\r",Xd);
UART_1_PutString(buff_U);

sprintf(buff_U, "Ns=%u\n\r",Ns);
UART_1_PutString(buff_U);

sprintf(buff_U, "GL=%u\n\r",Gain[Gain1[GainL]]);
UART_1_PutString(buff_U);

sprintf(buff_U, "GR=%u\n\r",Gain[Gain1[GainR]]);
UART_1_PutString(buff_U);

if(Sync==0) UART_1_PutString("Sync - L\n\r");  
else UART_1_PutString("Sync - R\n\r"); 

UART_1_PutString(">");

}
void PrintHelp(void)
{

UART_1_PutString("\n\ru   - Divider*10\n\r");
UART_1_PutString("d   - Divider/10\n\r");
UART_1_PutString("s   - Send Status\n\r");
UART_1_PutString("123 - Manual F input\n\r");
UART_1_PutString("l   - Sync from Left\n\r");
UART_1_PutString("r   - Sync from Right\n\r");

UART_1_PutString("f   - L Gain++\n\r");
UART_1_PutString("v   - L Gain--\n\r");
UART_1_PutString("g   - R Gain++\n\r");
UART_1_PutString("b   - R Gain--\n\r");


UART_1_PutString("h   - This Help\n\r");
UART_1_PutString(">");
}

void Display(void)
{


Xd = (uint16)(Freq / Fo);

LCD_Position(0,0);

sprintf(buff_LCD, "%6.0f ",FreqX);
LCD_PrintString(buff_LCD);

sprintf(buff_LCD, "%3u ",Xd);
LCD_PrintString(buff_LCD);

sprintf(buff_LCD, "%2u  ",Ns);
LCD_PrintString(buff_LCD);

LCD_Position(1,0);

sprintf(buff_LCD, "%6.0f ",Fs);
LCD_PrintString(buff_LCD);

sprintf(buff_LCD, "%2u ",Gain[Gain1[GainL]]);
LCD_PrintString(buff_LCD);

sprintf(buff_LCD, "%2u  ",Gain[Gain1[GainR]]);
LCD_PrintString(buff_LCD);

if(Sync==0) LCD_PrintString("L");  
else LCD_PrintString("R"); 

//sprintf(buff_LCD, "P=%u ",(uint32)Phase);
//LCD_PrintString(buff_LCD);

}

void UpdateF(void)
	{
	char i;
	if (count>2)
		{
		Auto=0;
		
		buff_U[count-1]=0;
		Fs = atoul(buff_U,10);
		
		Fs=(float)Fs;
		
		PhaseF = Acc*Fs;
		PhaseF = PhaseF/Fdds;
		
		Phase = (uint32)PhaseF;
		
		PhaseLo=Lo(Phase);
		PhaseMe=Me(Phase);
		PhaseHi=Hi(Phase);	
		
		CRegLo_Write(Lo(Phase));
		CRegMe_Write(Me(Phase));
		CRegHi_Write(Hi(Phase));
		
		LCD_Position(1,0);
		LCD_PrintString(buff_U);
		for(i=0;i<count;i++) buff_U[i] = 0;
		
		}
	count = 0;
	
	isr_1_Enable();
	
	UART_1_WriteTxData(13);
	UART_1_WriteTxData(10);
	UART_1_PutString("F?>");
	}
void Set_Fs(void)
{
	PhaseF = Acc*Fs;
	PhaseF = PhaseF/Fdds;

	Phase = (uint32)PhaseF;
	
//	Phase = Phase>>1;
//	Phase = Phase<<1;
	
	PhaseLo=Lo(Phase);
	PhaseMe=Me(Phase);
	PhaseHi=Hi(Phase);	
	
	CRegLo_Write(Lo(Phase));
	CRegMe_Write(Me(Phase));
	CRegHi_Write(Hi(Phase));
}

unsigned long atoul(char * s, unsigned base) {
   unsigned long result = 0;
   int temp;
   while( isspace(*s) ) ++s;
   do {
      temp = (*s++)&0xff;
      if( isdigit(temp) )  {
         temp -= '0';
      } else {
         if( isalpha(temp) ) {
            temp = toupper(temp)-'A'+10;
         } else {
            break;
         }
      }
      if( temp >= base )
         break;
      result *= base;
      result += temp;
   } while( 1 );
   return result;
}

uint8 Lo(uint32 Val)
{
uint8 Low;
Low = (uint8)(Val & 0xFF);
return Low;
}

uint8 Me(uint32 Val)
{
uint8 Med;
Val = Val>>8;
Med = (uint8)(Val & 0xFF);
return Med;
}

uint8 Hi(uint32 Val)
{
uint8 High;
Val = Val>>16;
High = (uint8)(Val & 0xFF);
return High;
}
//=================================================
void Convert(void)
{
	Fs = Freq - Fo;
	Fs = Fs / K;
	
	Ns = Fs / Fo;
    Ns = 2 * Ns;
	
 ////   If Fs <> Fsbak Then Print #1 , Fs
 //   sprintf(buff_U, "%u   ",(uint32)Fs);	//	'Print #1 , Fs
//	UART_1_PutString(buff_U);
    Fsbak = Fs;

    if (Ns < 50) //Then
	{
    K--;
    if (K == 0) K = 1;	
    }

    if (Ns > 100)	// Then
	{
    K++;
    if (K >= 100) K = 100;	
	}
}
void Convertx(void)
{
    Fs = FreqX / X;
    Fs = FreqX - Fs;
    Fo = FreqX - Fs;
    Fs = Fs / K;

    Ns = (uint8)(Fs / Fo);

 //   if (Fs > 10000) K++;
	
//    if (Ns < 48) 
//	{
//    X = X * 10;
//    K--;
//	}

//	if (Fs != Fsbak)
//	{
//	sprintf(buff_U, "%7.1f ",Fs);	
//	UART_1_PutString(buff_U);
//	}
    Fsbak = Fs;
}



/*
Sub Convert()
    Fs = Freq - Fo
    Fs = Fs / K
    Fs = Fs / 2



 '   If Fs <> Fsbak Then Print #1 , Fs
    Print #1 , Fs
    Fsbak = Fs

    If Ns < 50 Then
    Decr K
    If K = 0 Then K = 1
    End If

    If Ns > 100 Then
    Incr K
    If K >= 100 Then K = 100
    End If
End Sub

Sub Convertx()
    Fs = Freq / X

    Fs = Freq - Fs

    Fo = Freq - Fs

    Fs = Fs / K

    Ns = Fs \ Fo

'    If Fs > 10000 Then Incr K
'    If Ns < 48 Then
'    X = X * 10
'    Decr K
'    End If

    Fs = Fs / 2
    If Fs <> Fsbak Then Print #1 , Fs
  '  Print #1 , Fs
    Fsbak = Fs

End Sub
*/

/* [] END OF FILE */
